"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("./utils");

var getRouteFromLocation = function getRouteFromLocation(routes, location) {
  return routes.find(function (route) {
    return route.locationMatch(location);
  });
};

var parseValues = function parseValues(route, values) {
  return Object.values(route.params).filter(function (_ref) {
    var name = _ref.name;
    return name in values;
  }).map(function (_ref2) {
    var key = _ref2.key,
        name = _ref2.name,
        parse = _ref2.parse;
    return [key, parse(values[name])];
  }).reduce(_utils.createObject, {});
};

var _default = function _default(routes, location) {
  var route = getRouteFromLocation(routes, location);
  var redirected = (0, _utils.redirect)(routes, route);

  if (redirected !== undefined) {
    var locationValues = route.getParamValues(location);
    var paramValues = parseValues(redirected, locationValues);
    return (0, _utils.createSpec)(redirected, paramValues);
  } else {
    return undefined;
  }
};

exports.default = _default;